package org.ucam.srcf.assassins;

import java.io.IOException;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import org.ucam.srcf.assassins.exceptions.AssassinSQLException;
import org.ucam.srcf.assassins.exceptions.StateBuilderException;
import org.ucam.srcf.assassins.xml.Config;

public class HeadlinesCreator extends PageCreator {
   
   private String base;
   
   public HeadlinesCreator(String page, Map plugins) throws IOException {
      this(page, plugins, new HeadlineComparator());
   }
   
   public HeadlinesCreator(String page, Map plugins, Comparator c) throws IOException {
      super(page,plugins,c);
      base = page.substring(0,page.length()-4);
      // super.setDays(new HashMap());
   }

   public void generate () throws AssassinSQLException, StateBuilderException {
      if (Debug.debug) Debug.print(HeadlinesCreator.class,"generate() called for "+target);
      out.println("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>");
      out.println("<!DOCTYPE webpage SYSTEM \"NewsPage.dtd\" >");
      out.println("<webpage>");
      out.println("  <title>Headlines</title>");
      //Iterator iterator = (days.keySet()).iterator();
      Iterator iterator = events.iterator();
      String lastDay = "";
      out.println("  <events>");
      while (iterator.hasNext()) {
         Event e = (Event) iterator.next();
         //Long t = (Long) iterator.next();
         //String t = (String) iterator.next();
         //StringTokenizer s = new StringTokenizer(t);
         //out.println("    <day>"+s.nextToken()+"</day>");
         String day = Tools.prettyDate(e.getEventTime());
         if (!(lastDay.equals(day)))
         {
            lastDay = day;
            out.println("    <day>"+day+"</day>");
         }
         //Iterator it = ((Vector)days.get(t)).iterator();
         //while (it.hasNext()) {
            //Event e = (Event) it.next();
            Map map = e.getParticipants();
            Map mapP = e.getParticipantPseudonyms();
            Iterator mapIt = (map.keySet()).iterator();
            Map parttoRepl = new HashMap();
            while (mapIt.hasNext()) {
               Integer x = (Integer) mapIt.next();
               Pseudonym p = (Pseudonym) mapP.get(x);
               Assassin t2 = (Assassin) map.get(x);
               parttoRepl = updatePseudonymMap(parttoRepl, x, t2, p, e);
            }
            String url = ((PageCreator) references.get(e)).getLinkName();
            out.println("    <event-summary>");
            out.println("      <time>"+Tools.prettyTime(e.getEventTime())+"</time>");
            out.println("      <reference cgipage='"+Config.getConfig("vanilla","cgiurl")+"?edit-event' page='"+url+"' event='"+(e.getEid()+Config.getConfigInt("vanilla","obscurity-offset"))+"'/>");
            out.println("      <headline>"+Tools.replace(e.getHeadline(),parttoRepl)+"</headline>");
            out.println("    </event-summary>");
         //}
      }
      out.println("  </events>");
      out.println("  <links>");
      for (Iterator i = getAllNewsPages().iterator(); i.hasNext();) {
      	NewsPage np = (NewsPage)i.next();
      	String l = np.getLinkName();
      	String t = np.getTitle();
      	out.println("   <a href=\""+l+"\">"+t+"</a>");
      }
      out.println("    <a href=\""+Config.getConfig("vanilla","updates-page-name")+".html\">Updates</a>");
      int index=1;
      String s=null;
      while (null!=(s=Config.getConfig("vanilla","template-page-name-"+index))) {
      	out.println("    <a href=\""+s+".html\">"+s+"</a>");
         index++;
      }
      out.println("  </links>");
      out.println("</webpage>");
      out.close();
      String xslt_template = Config.getConfig("vanilla","xsl-file");
      Tools.exec(new String[] {
         "/usr/bin/xsltproc",
         "--novalid",
         "-o",
         base+".html",
         xslt_template,
         base+".xml"});
      String admin_xslt_template = Config.getConfig("vanilla","admin-xsl-file");
      Tools.exec(new String[] {
         "/usr/bin/xsltproc",
         "--novalid",
         "-o",
         base+"-admin.html",
         admin_xslt_template,
         base+".xml"});
   }
   
   private static class HeadlineComparator implements java.util.Comparator {

      public HeadlineComparator() {}
      
      public int compare(Object o, Object p) {
         long e=0,f=0;
         try { 
            e = ((Event) o).getEventTime();
            f = ((Event) p).getEventTime();
         } catch (AssassinSQLException asqle) {
            if (Debug.debug) Debug.print(HeadlinesCreator.class, "could not get time");
         }
         if (e<f) return -1;
         if (e==f) return 0;
         return 1;
      }
   }
}
